/*
 * 
 */
package no.ntnu.map.indoormaps;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.BroadcastReceiver;
import android.content.ContentResolver;
import android.content.ContentUris;
import android.content.ContentValues;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.database.MatrixCursor;
import android.database.MergeCursor;
import android.net.Uri;
import android.net.wifi.ScanResult;
import android.net.wifi.WifiManager;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.ContextMenu;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ContextMenu.ContextMenuInfo;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.AdapterContextMenuInfo;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.ProgressBar;
import android.widget.ScrollView;
import android.widget.SimpleCursorAdapter;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

// TODO: Auto-generated Javadoc
/**
 * The Class NodeActivity.
 */
public class NodeActivity extends Activity
{

	/** TAG used with {@link IndMap#log(short, String, String)}. */
	private static final String	TAG	= "NodeActivity";

	/** The Constant UNSELECT_ACTION. */
	public static final String EDIT_NODE_ACTION = "no.ntnu.map.indoormaps.EDIT_NODE";

	/** The Constant UNSELECT_ACTION. */
	public static final String	UNSELECT_ACTION="fuubar";

	/** The Constant PREFERENCES. */
	private static final String	PREFERENCES	= "nodeact";

	/**
	 * The Class SelNodesCursorAdapter.
	 */
	public class SelNodesCursorAdapter extends ArrayAdapter<Node>
	{

		/** The DEBUG. */
		private final boolean DEBUG=false;

		private class DelOnClickListener implements OnClickListener
		{

			/** The pos. */
			private int pos;

			public DelOnClickListener(int i){pos=i;}

			public void onClick(View v)
			{
				final int id1=getNode(pos).getI();
				int id=0;
				switch (listM)
				{
					case DISP_MODE_PARENT:
						id=parent;
						break;
					case DISP_MODE_ROUTE:
						id=getNode(pos+1).getI();
						break;
				}
				final int id2=id;
				AlertDialog.Builder builder = new AlertDialog.Builder(NodeActivity.this);
				builder.setMessage("Want to delete link?")
				.setCancelable(true)
				.setPositiveButton("Yes", new DialogInterface.OnClickListener()
				{
					public void onClick(DialogInterface dialog, int id)
					{
						try{
							getContext().getContentResolver().delete(Uri.withAppendedPath(Provider.CONTENT_URI, Node.TABLE_NAME+"/"+id1+"/"+Node.TABLE_NAME+"/"+id2), null, null);
						}catch (Exception e) {
							IndMap.log(IndMap.ERROR, TAG, "Database error "+e.toString());
						}
						somethingEdited=true;
						remove(id1);
						updNodeSel();
						dialog.cancel();
					}
				})
				.setNegativeButton("No", new DialogInterface.OnClickListener()
				{

					public void onClick(DialogInterface dialog, int which)
					{
						dialog.cancel();
					}
				});
				AlertDialog alert = builder.create();
				alert.show();
			}
		}

		/**
		 * The Class TWatcher.
		 */
		private class TWatcher implements TextWatcher
		{

			/** The pos. */
			private int pos;

			/** The view. */
			private View view;

			/**
			 * Instantiates a new t watcher.
			 *
			 * @param i the i
			 * @param v the v
			 */
			public TWatcher(int i,View v){pos=i;view=v;}

			/* (non-Javadoc)
			 * @see android.text.TextWatcher#afterTextChanged(android.text.Editable)
			 */
			public void afterTextChanged(Editable s)
			{
				try{cost[pos]=Float.valueOf(s.toString());}
				catch (Exception e) {}
				view.requestFocus();
			}

			/* (non-Javadoc)
			 * @see android.text.TextWatcher#beforeTextChanged(java.lang.CharSequence, int, int, int)
			 */
			public void beforeTextChanged(CharSequence s, int start, int count, int after){}

			/* (non-Javadoc)
			 * @see android.text.TextWatcher#onTextChanged(java.lang.CharSequence, int, int, int)
			 */
			public void onTextChanged(CharSequence s, int start, int before, int count){}
		}

		/** The nos. */
		private ArrayList<Node> nos=new ArrayList<Node>();

		/** The cost. */
		private float[] cost=new float[0];

		/** The hm. */
		private HashMap<Integer,Integer> hm=new HashMap<Integer,Integer>();

		/** The list m. */
		private short listM=DISP_MODE_ROUTE; //Route or Parent View!

		/** The node m. */
		private short nodeM; // What to return on save

		/** The parent. */
		private int parent=-1;

		/** The clicked id. */
		private int clickedId=-1;

		/** The otcl. */
		private OnItemClickListener otcl;

		/** The otcl. */
		private OnLongClickListener olcl;

		/** The Constant SEL_MODE_NONE. */
		public static final short DISP_MODE_ROUTE=0;

		/** The Constant SEL_MODE_NONE. */
		public static final short	DISP_MODE_PARENT=1;

		/** The Constant SEL_MODE_NONE. */
		public static final short	SEL_MODE_LAST=0;

		/** The Constant SEL_MODE_NONE. */
		public static final short	SEL_MODE_FIRST=1;

		/** The Constant SEL_MODE_NONE. */
		public static final short	SEL_MODE_NONE=2;

		/*public SelNodesCursorAdapter(Context context, int textViewResourceId, short nodeM, final short listMode)
		{
			super(context, textViewResourceId);
			listM=listMode;
			parent=-1;
		}*/
		/**
		 * Instantiates a new sel nodes cursor adapter.
		 *
		 * @param context the context
		 * @param textViewResourceId the text view resource id
		 * @param nodeM the node m
		 * @param parent_id the parent_id
		 * @param lis the lis
		 * @param las the las
		 */
		public SelNodesCursorAdapter(Context context, int textViewResourceId, final short nodeM, int parent_id,OnItemClickListener lis,OnLongClickListener las)
		{
			super(context, textViewResourceId);
			this.nodeM=nodeM;
			setParent(parent_id);
			otcl=lis;
			olcl=las;
		}

		/**
		 * Instantiates a new sel nodes cursor adapter.
		 *
		 * @param c the c
		 * @param textViewResourceId the text view resource id
		 * @param lMode the l mode
		 * @param parent_id the parent_id
		 * @param from the from
		 */
		public SelNodesCursorAdapter(Context c, int textViewResourceId, final short lMode, int parent_id,SelNodesCursorAdapter from)
		{
			super(c, textViewResourceId);
			setParent(parent_id);
			setListMode(c,lMode);
			importFrom(c,from);
		}

		/**
		 * Instantiates a new sel nodes cursor adapter.
		 *
		 * @param c the c
		 * @param textViewResourceId the text view resource id
		 * @param nMode the n mode
		 * @param lMode the l mode
		 * @param parent_id the parent_id
		 */
		public SelNodesCursorAdapter(Context c, int textViewResourceId,short nMode,short lMode,int parent_id)
		{
			super(c, textViewResourceId);
			parent=parent_id;
			nodeM=nMode;
			setListMode(c,lMode);
		}

		/**
		 * Gets the nodes.
		 *
		 * @return the nodes
		 */
		ArrayList<Node> getNodes()
		{
			return nos;
		}

		/**
		 * Gets the selected by id.
		 *
		 * @return the selected by id
		 */
		public int[] getSelectedById()
		{
			int[] ret=new int[nos.size()];
			for(int i=0;i<nos.size();i++)ret[i]=nos.get(i).getI();
			return ret;
		}

		/**
		 * Import from.
		 *
		 * @param c the c
		 * @param from the from
		 */
		private void importFrom(Context c, SelNodesCursorAdapter from)
		{
			nos=new ArrayList<Node>(from.getNodes());
			nodeM=from.getNodeMode();
			loadCost(c);
		}

		/**
		 * Sets the node mode.
		 *
		 * @param nMode the new node mode
		 */
		public void setNodeMode(final short nMode)
		{
			if(DEBUG)IndMap.log(IndMap.DEBUG, TAG, "SeNoCrAd: SetNodeMode: "+nMode);
			nodeM=nMode;
		}

		/**
		 * Gets the node mode.
		 *
		 * @return the node mode
		 */
		public short getNodeMode(){return nodeM;}

		/**
		 * Sets the list mode.
		 *
		 * @param c the c
		 * @param lMode the l mode
		 */
		public void setListMode(Context c, final short lMode)
		{
			if(parent>0)listM=lMode;
			else listM=DISP_MODE_ROUTE;
			if(DEBUG)IndMap.log(IndMap.DEBUG, TAG, "SeNoCrAd: SetListMode: "+lMode+(parent<0?" but parent_id: "+parent:""));
			if(hm.containsKey(parent))remove(parent);
			loadCost(c);
		}

		/**
		 * Load cost.
		 *
		 * @param c the c
		 */
		private void loadCost(Context c)
		{
			Cursor a=null;
			cost=new float[nos.size()];
			for(int i=0;i<nos.size();i++)switch (listM)
			{
				case DISP_MODE_PARENT:
					a=c.getContentResolver().query(
							Uri.withAppendedPath(Provider.CONTENT_URI, Node.TABLE_NAME+"/"+parent+"/"+Node.TABLE_NAME+"/"+nos.get(i).getI()),
							null, null, null, null);
					if(a.moveToFirst())
					{
						cost[i]=a.getFloat(a.getColumnIndexOrThrow(Node.CHILD_COST));
					}
					else cost[i]=0.0f;
					a.close();
					break;
				case DISP_MODE_ROUTE:
					if(i<1)break;
					int id1=nos.get(i-1).getI(),
					id=nos.get(i).getI();
					a=c.getContentResolver().query(
							Uri.withAppendedPath(Provider.CONTENT_URI, Node.TABLE_NAME+"/"+id1+"/"+Node.TABLE_NAME+"/"+id),
							null, null, null, null);
					if(a.moveToFirst())
					{
						cost[i-1]=a.getFloat(a.getColumnIndexOrThrow(Node.CHILD_COST));
					}
					else cost[i]=0.0f;
					a.close();
					break;
			}
			if(a!=null)a.close();			
		}

		/**
		 * Gets the clicked id.
		 *
		 * @return the clicked id
		 */
		public int getClickedId(){return clickedId;}

		/**
		 * Gets the list mode.
		 *
		 * @return the list mode
		 */
		public short getListMode(){return listM;}

		/**
		 * Sets the parent.
		 * @param id  the new parent
		 * @uml.property  name="parent"
		 */
		public void setParent(int id)
		{
			if(hm.containsKey(new Integer(id)))remove(id);
			parent=id;
			if(id<0)listM=DISP_MODE_ROUTE;
			if(DEBUG)IndMap.log(IndMap.DEBUG, TAG, "SeNoCrAd: SetParent: "+id+(parent<0?" Parent_id<0: so RouteMode":""));
		}

		/**
		 * Gets the parent.
		 * @return  the parent
		 * @uml.property  name="parent"
		 */
		public int getParent(){return parent;}

		/**
		 * Adds the.
		 *
		 * @param c the c
		 * @param id the id
		 */
		public void add(Context c,int id)
		{
			if(id==parent&&listM==DISP_MODE_PARENT)throw new IllegalArgumentException("The parent can't be part of the it's children");
			if(hm.containsKey(new Integer(id)))return;
			if(DEBUG)IndMap.log(IndMap.DEBUG, TAG, "SeNoCrAd: Adding "+id+"..");

			Cursor a=c.getContentResolver().query(
					Uri.withAppendedPath(Provider.CONTENT_URI, Node.TABLE_NAME+"/"+id),
					null, null, null, null);

			if(a.moveToFirst())
			{
				hm.put(id, nos.size());
				int now=nos.size();
				Node n=new Node(a);
				nos.add(now, n);
				loadCost(c);

				/*
				float[] tmp=new float[now+1];
				int i;
				for(i=0;i<tmp.length;i++)
				{
					if(i>=cost.length)tmp[i]=0.0f;
					else tmp[i]=cost[i]; 
				}
				cost=tmp;*/
				/*
				a.close();
				switch (listM)
				{
					case DISP_MODE_PARENT:
						a=c.getContentResolver().query(
								Uri.withAppendedPath(Provider.CONTENT_URI, Node.TABLE_NAME+"/"+parent+"/"+Node.TABLE_NAME+"/"+id),
								null, null, null, null);
						if(a!=null&&a.moveToFirst())
						{
							do{cost[now]=a.getFloat(a.getColumnIndexOrThrow(Node.CHILD_COST));}
							while(a.moveToNext());
						}
						break;
					case DISP_MODE_ROUTE:
						if(now<1)break;
						int id1=nos.get(now-1).getI();
						a=c.getContentResolver().query(
								Uri.withAppendedPath(Provider.CONTENT_URI, Node.TABLE_NAME+"/"+id1+"/"+Node.TABLE_NAME+"/"+id),
								null, null, null, null);
						if(a!=null&&a.moveToFirst())
							cost[now-1]=a.getFloat(a.getColumnIndexOrThrow(Node.CHILD_COST));
						break;
				}*/
			}
			if(a!=null)a.close();
		}

		/**
		 * Removes the.
		 *
		 * @param id the id
		 */
		public void remove(int id)
		{
			if(DEBUG)IndMap.log(IndMap.DEBUG, TAG, "SeNoCrAd: Remove");
			if(hm.get(id)==null)
			{
				if(DEBUG)IndMap.log(IndMap.DEBUG, TAG, "SeNoCrAd: Remove: did not find element with id "+id);
				return;
			}
			int i=hm.get(id).intValue();
			nos.remove(i);
			hm.remove(id);
			float[] tmp=new float[nos.size()];
			for(int j=0;j<i;j++)tmp[j]=cost[j];
			for(int j=i;j<nos.size();j++) //Rebuilding HashMap and cost-array
			{
				hm.put(nos.get(j).getI(), j);
				tmp[j]=cost[j+1];				
			}
			cost=tmp;
		}

		/**
		 * Removes the all.
		 */
		void removeAll()
		{
			nos.clear();
			cost=new float[0];
			hm=new HashMap<Integer, Integer>();
			clear();
		}

		/**
		 * Gets the node.
		 *
		 * @param pos the pos
		 * @return the node
		 */
		public Node getNode(int pos)
		{
			switch (listM)
			{
				case DISP_MODE_ROUTE:
					return nos.get(((pos-pos%2)/2));
				default:
					int id=clickedId;
					clickedId=-1;
					if(pos>-1) return nos.get(pos); 
					else return nos.get(hm.get(id).intValue()); 
			}
		}

		/**
		 * Size.
		 *
		 * @return the int
		 */
		public int size(){return nos.size();}

		/* (non-Javadoc)
		 * @see android.widget.ArrayAdapter#getCount()
		 */
		@Override
		public int getCount()
		{
			switch(listM)
			{
				case DISP_MODE_ROUTE:
					return nos.size()*2-1;
			}
			return nos.size();
		}

		/* (non-Javadoc)
		 * @see android.widget.ArrayAdapter#getView(int, android.view.View, android.view.ViewGroup)
		 */
		public View getView(int pos, View convertView, ViewGroup parent)
		{
			View v = convertView;
			LayoutInflater vi = (LayoutInflater) getContext().getSystemService(Context.LAYOUT_INFLATER_SERVICE);

			TextView name,desc,n1,n2;
			EditText cos;
			Button del;
			Node n,no;

			switch(listM)
			{
				case DISP_MODE_PARENT:
					v = vi.inflate(R.layout.node_sel_par_item, null);
					v.setFocusable(true);
					n=nos.get(pos);

					v.setTag(new Integer(n.getI()));

					name= (TextView) v.findViewById(R.id.name);
					desc= (TextView) v.findViewById(R.id.desc);
					cos=  (EditText) v.findViewById(R.id.cost);
					del= (Button) v.findViewById(R.id.dodel);

					if(del!=null)del.setOnClickListener(new DelOnClickListener(pos));
					if(name!=null)
					{
						name.setText(n.getI()+" - "+n.getName());
						name.setTag(new Integer(n.getI()));
					}
					if(desc!=null)
					{
						desc.setText(n.getDesc());
						desc.setTag(new Integer(n.getI()));
					}
					if(cos!=null)
					{
						cos.setText(""+cost[pos]);
						cos.addTextChangedListener(new TWatcher(pos,cos));
						cos.setOnClickListener(new OnClickListener()
						{
							//GUI FIX
							public void onClick(View v){v.requestFocus();}
						});
					}

					final long id=n.getI();
					v.setOnClickListener(new OnClickListener()
					{
						//EVER WORST HACK EVER!!!!! Reason: the editText view kills the onitemselected for the seleced nodes list
						public void onClick(View v)
						{
							otcl.onItemClick(null, null, 0, id);
						}
					});

					v.setOnLongClickListener(new OnLongClickListener()
					{
						//EVER WORST HACK EVER!!!!! Reason: the editText view kills the contextmenu onlongclick function for the seleced nodes list						
						public boolean onLongClick(View v)
						{
							if(v.getTag() instanceof Integer)clickedId=((Integer)v.getTag()).intValue();
							return olcl.onLongClick(v);
						}
					});
					break;

				case DISP_MODE_ROUTE:
					int i=(pos-(pos%2))/2;
					n=nos.get(i);
					if(pos%2==0)
					{
						v=vi.inflate(R.layout.node_sel_rou_item, null);
						name= (TextView) v.findViewById(R.id.name);
						desc= (TextView) v.findViewById(R.id.desc);
						if(name!=null)name.setText(n.getI()+" - "+n.getName());
						if(desc!=null)desc.setText(n.getDesc());
					}
					else
					{
						v=vi.inflate(R.layout.node_sel_rou_et_item, null);
						n1=  (TextView) v.findViewById(R.id.node1);
						n2=  (TextView) v.findViewById(R.id.node2);
						cos= (EditText) v.findViewById(R.id.cost);
						del= (Button) v.findViewById(R.id.dodel);

						if(del!=null)del.setOnClickListener(new DelOnClickListener(i));

						no=nos.get(i+1);
						if(n1!=null)n1.setText(n.getI()+" - "+n.getName()+" ->");
						if(n2!=null)n2.setText("<- "+no.getI()+" - "+no.getName());
						if(cos!=null)
						{
							cos.setText(""+cost[i]);
							cos.addTextChangedListener(new TWatcher(i,cos));
							cos.setOnClickListener(new OnClickListener()
							{
								//GUI FIX
								public void onClick(View v)
								{
									v.requestFocus();
								}
							});
						}
					}
			}
			return v;
		}

		/* (non-Javadoc)
		 * @see android.widget.ArrayAdapter#getItemId(int)
		 */
		public long getItemId(int pos)
		{
			switch(listM)
			{
				default:
					return nos.get(pos).getI();
				case DISP_MODE_ROUTE:
					int i= (pos-pos%2)/2;
					return nos.get(i).getI();
			}
		}

		/**
		 * Save and get node id.
		 *
		 * @param c the c
		 */
		public void saveAndGetNodeId(Context c)
		{
			if(DEBUG)IndMap.log(IndMap.DEBUG, TAG, "SeNoCrAd: SAVE");
			ContentResolver cr=c.getContentResolver();
			Uri nn=Uri.withAppendedPath(Provider.CONTENT_URI, Node.TABLE_NAME+Node.TABLE_NAME);
			int i;
			int id1,id2;
			ContentValues val;
			switch(listM)
			{
				case DISP_MODE_PARENT:
					//cr.delete(ContentUris.withAppendedId(nn, parent_id), null, null);
					for(i=0;i<nos.size();i++)
					{
						id1=parent;
						id2=nos.get(i).getI();
						val=new ContentValues(3);
						val.put(Node.CHILD_COST, cost[i]);
						try{cr.update(Uri.withAppendedPath(
								Provider.CONTENT_URI, Node.TABLE_NAME+"/"+id1+"/"+Node.TABLE_NAME+"/"+id2), 
								null, null, null);}
						catch (Exception e) {
							val.put(Node.PARENTA, (id1<id2?id1:id2));
							val.put(Node.PARENTB, (id1<id2?id2:id1));
							try{cr.insert(nn, val);}
							catch (Exception e1) {}
						}
					}
					break;
				case DISP_MODE_ROUTE:
					for(i=0;i<nos.size()-1;i++)
					{
						val=new ContentValues();
						id1=nos.get(i).getI();
						id2=nos.get(i+1).getI();
						val.put(Node.CHILD_COST, cost[i]);
						try{cr.update(Uri.withAppendedPath(
								Provider.CONTENT_URI, Node.TABLE_NAME+"/"+id1+"/"+Node.TABLE_NAME+"/"+id2), 
								null, null, null);}
						catch (Exception e) {
							val.put(Node.PARENTA, id1);
							val.put(Node.PARENTB, id2);
							try{cr.insert(nn, val);}
							catch (Exception e1) {}
						}
					}
			}
			i=-1;
			switch (nodeM)
			{
				case SEL_MODE_FIRST:
					i=nos.get(0).getI();
					break;
				case SEL_MODE_LAST:
					i=nos.get(nos.size()-1).getI();
					break;
			}
			removeAll();
			if(i>0)add(c,i);
		}
	}

	/**
	 * The Class ApListCursorAdapter.
	 */
	public static class ApListCursorAdapter extends ArrayAdapter<Ap>
	{

		//TODO Sources http://www.softwarepassion.com/android-series-custom-listview-items-and-adapters/
		//TODO Sources http://appfulcrum.com/?p=311
		/**
		 * The listener interface for receiving onCheckedChange events.
		 * The class that is interested in processing a onCheckedChange
		 * event implements this interface, and the object created
		 * with that class is registered with a component using the
		 * component's <code>addOnCheckedChangeListener<code> method. When
		 * the onCheckedChange event occurs, that object's appropriate
		 * method is invoked.
		 *
		 * @see OnCheckedChangeListener
		 */
		private class CheckedChangeListener implements OnCheckedChangeListener
		{

			/** The pos. */
			private int pos;

			/**
			 * Instantiates a new on checked change listener.
			 *
			 * @param pos the pos
			 */
			public CheckedChangeListener(int pos){this.pos=pos;}

			/* (non-Javadoc)
			 * @see android.widget.CompoundButton.OnCheckedChangeListener#onCheckedChanged(android.widget.CompoundButton, boolean)
			 */
			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked){checked[pos]=isChecked;}
		}

		/** The aps. */
		private ArrayList<Ap> aps;

		/** The freq. */
		private int[] level;

		/** The freq. */
		private int[]	freq;

		/** The checked. */
		private boolean[] checked;

		/** The got levels. */
		private boolean sList;

		/** The got levels. */
		private boolean	gotLevels=false;

		/** The Constant NONSELECT_VIEW. */
		protected static final boolean SELECT_VIEW=true;

		/** The Constant NONSELECT_VIEW. */
		protected static final boolean	NONSELECT_VIEW=false;

		/**
		 * Instantiates a new ap list cursor adapter.
		 *
		 * @param context the context
		 * @param textViewResourceId the text view resource id
		 * @param c the c
		 * @param selectList the select list
		 */
		public ApListCursorAdapter(Context context, int textViewResourceId,Cursor c, final boolean selectList)
		{
			super(context, textViewResourceId);
			createByCursor(c,new Ap[0],selectList);
		}

		/**
		 * Instantiates a new ap list cursor adapter.
		 *
		 * @param context the context
		 * @param textViewResourceId the text view resource id
		 * @param c the c
		 * @param knownAps the known aps
		 * @param selectList the select list
		 */
		public ApListCursorAdapter(Context context, int textViewResourceId,Cursor c, Ap[] knownAps, final boolean selectList)
		{
			super(context, textViewResourceId);
			createByCursor(c,knownAps,selectList);
		}

		/**
		 * Instantiates a new ap list cursor adapter.
		 *
		 * @param context the context
		 * @param textViewResourceId the text view resource id
		 */
		public ApListCursorAdapter(Context context, int textViewResourceId)
		{
			super(context, textViewResourceId);
			create(false);
		}

		/**
		 * Instantiates a new ap list cursor adapter.
		 *
		 * @param context the context
		 * @param textViewResourceId the text view resource id
		 * @param selectList the select list
		 */
		public ApListCursorAdapter(Context context, int textViewResourceId, final boolean selectList)
		{
			super(context, textViewResourceId);
			create(selectList);
		}

		/**
		 * Instantiates a new ap list cursor adapter.
		 *
		 * @param context the context
		 * @param textViewResourceId the text view resource id
		 * @param sr the sr
		 * @param known the known
		 * @param selectList the select list
		 * @param filterUnknown the filter unknown
		 */
		public ApListCursorAdapter(Context context, int textViewResourceId, List<ScanResult> sr, Ap[] known,final boolean selectList, boolean filterUnknown)
		{
			super(context, textViewResourceId);
			init(selectList,sr.size());

			gotLevels=true;
			Iterator<ScanResult> i=sr.iterator();
			ArrayList<Integer> lev=new ArrayList<Integer>(sr.size()),fre=new ArrayList<Integer>(sr.size());
			ArrayList<Boolean> che=new ArrayList<Boolean>(sr.size());
			while(i.hasNext())
			{
				ScanResult s=i.next();
				if(IndMap.FIND_AT_NODE_DEBUG)IndMap.log(IndMap.DEBUG, TAG, "Found: "+s.toString());
				if(filterUnknown&&!Ap.containsByBSSID(known, Ap.stringSSID2long(s.BSSID,Ap.BSSID_SEPERATOR)))break;
				if(IndMap.FIND_AT_NODE_DEBUG)IndMap.log(IndMap.DEBUG, TAG, "  - Added");
				che.add(addIsChecked(known, -1, s.SSID, s.BSSID, false));
				lev.add(new Integer(s.level));
				fre.add(new Integer(s.frequency));
			}
			set(lev, fre, che);
		}

		/**
		 * Creates the.
		 *
		 * @param selectList the select list
		 */
		private void create(final boolean selectList)
		{
			init(selectList,10);
		}

		/**
		 * Creates the by cursor.
		 *
		 * @param c the c
		 * @param known the known
		 * @param selectList the select list
		 */
		private void createByCursor(Cursor c, Ap[] known, final boolean selectList)
		{
			final int ID_COL    = c.getColumnIndexOrThrow(Ap._ID);
			final int NAME_COL  = c.getColumnIndexOrThrow(Ap.NAME);
			final int BSSID_COL = c.getColumnIndexOrThrow(Ap.BSSID);
			final int LEVEL_COL = c.getColumnIndex(Ap.LEVELatNODE);

			if((selectList||LEVEL_COL<0)&&known.length<1)throw new IllegalArgumentException();
			init((selectList||LEVEL_COL<0),c.getCount()); //If no level column, then force selectlist. (need level column to show level-bar)

			if(LEVEL_COL<0) gotLevels=false;
			else 			gotLevels=true;

			ArrayList<Integer> lev=new ArrayList<Integer>(c.getCount()),fre=new ArrayList<Integer>(c.getCount());
			ArrayList<Boolean> che=new ArrayList<Boolean>(c.getCount());
			if(!c.moveToFirst())return;
			do
			{
				if(c.getInt(LEVEL_COL)<0)
					lev.add(new Integer(c.getInt(LEVEL_COL)));
				fre.add(new Integer(-1));
				che.add(addIsChecked(known, c.getInt(ID_COL),c.getString(NAME_COL), c.getString(BSSID_COL), false));
			}
			while(c.moveToNext());
			set(lev, fre,che);
		}

		/**
		 * Inits the.
		 *
		 * @param selectList the select list
		 * @param count the count
		 */
		private void init(boolean selectList,int count)
		{
			sList   = selectList;
			aps     = new ArrayList<Ap>(count);
			level   = new int[count];
			freq    = new int[count];
			checked = new boolean[count];
		}

		/**
		 * Adds the is checked.
		 *
		 * @param known the known
		 * @param id the id
		 * @param ssid the ssid
		 * @param bssid the bssid
		 * @param checked the checked
		 * @return the boolean
		 */
		private Boolean addIsChecked(Ap[] known,int id,String ssid,String bssid,boolean checked)
		{
			Ap a=null;
			if(known.length>0)
			{
				a=Ap.getApByBSSID(known, Ap.stringSSID2long(bssid,Ap.BSSID_SEPERATOR));
			}
			boolean ret=a==null;
			if(ret)a=new Ap(id, ssid, bssid);
			aps.add(a);
			super.add(a);
			return new Boolean(!ret||checked);
		}

		/**
		 * Adds the.
		 *
		 * @param known the known
		 * @param id the id
		 * @param ssid the ssid
		 * @param bssid the bssid
		 */
		public void add(Ap[] known,int id,String ssid,String bssid){addIsChecked(known, id, ssid, bssid, false);}

		/**
		 * Sets the.
		 *
		 * @param levels the levels
		 * @param freqv the freqv
		 */
		public void set(ArrayList<Integer> levels, ArrayList<Integer> freqv){set(levels, freqv, null);}

		/**
		 * Sets the.
		 *
		 * @param levels the levels
		 * @param freqv the freqv
		 * @param chec the chec
		 */
		private void set(ArrayList<Integer> levels, ArrayList<Integer> freqv,ArrayList<Boolean> chec)
		{
			for(int i=0;i<levels.size();i++)
			{
				level[i]=levels.get(i).intValue();
				freq[i]=freqv.get(i).intValue();
				checked[i]=(chec!=null?chec.get(i).booleanValue():false);
			}
		}

		/* (non-Javadoc)
		 * @see android.widget.ArrayAdapter#getView(int, android.view.View, android.view.ViewGroup)
		 */
		public View getView(int pos, View convertView, ViewGroup parent)
		{
			View v = convertView;
			if (v == null)
			{
				LayoutInflater vi = (LayoutInflater) getContext().getSystemService(Context.LAYOUT_INFLATER_SERVICE);
				if(sList) v = vi.inflate(R.layout.aplist_sttp_item, null);

				else v = vi.inflate(R.layout.aplist_ttp_item, null);
			}
			Ap ap = aps.get(pos);
			if (ap != null)
			{
				TextView ssid  = (TextView) v.findViewById(R.id.ssid);
				TextView mac   = (TextView) v.findViewById(R.id.mac);
				ProgressBar pb = (ProgressBar) v.findViewById(R.id.level);
				CheckBox cb    = (CheckBox) v.findViewById(R.id.checker);
				if(ssid != null)ssid.setText(ap.getName() +"  "+level[pos]+" db");
				if(mac != null)mac.setText("MAC: "+ap.getBssidString());
				if(pb != null)
				{
					int lev=130+level[pos];
					if(lev<0 || !gotLevels)pb.setVisibility(View.GONE);
					else
					{
						pb.setProgress((lev>100?100:lev));
						pb.setVisibility(View.VISIBLE);
					}
				}
				if(cb != null)
				{
					cb.setChecked(checked[pos]);
					cb.setOnCheckedChangeListener(new CheckedChangeListener(pos));
				}
			}
			return v;
		}

		/* (non-Javadoc)
		 * @see android.widget.ArrayAdapter#getCount()
		 */
		public int getCount(){return aps.size();}

		/**
		 * Gets the id.
		 *
		 * @param index the index
		 * @return the id
		 */
		public int getId(int index)
		{
			return aps.get(index).getI();
		}

		/**
		 * Gets the sSID.
		 *
		 * @param index the index
		 * @return the sSID
		 */
		public String getSSID(int index)
		{
			return aps.get(index).getName();
		}

		/**
		 * Gets the bssid.
		 *
		 * @param index the index
		 * @return the bssid
		 */
		public long getBssid(int index){return aps.get(index).getBssid();}

		/**
		 * Gets the bssid string.
		 *
		 * @param index the index
		 * @return the bssid string
		 */
		public String getBssidString(int index){return aps.get(index).getBssidString();}

		/**
		 * Gets the aps.
		 * @return  the aps
		 * @uml.property  name="aps"
		 */
		public Ap[] getAps()
		{
			Ap[] ret=new Ap[aps.size()];
			aps.toArray(ret);
			return ret;
		}

		/**
		 * Gets the ap.
		 *
		 * @param index the index
		 * @return the ap
		 */
		public Ap getAp(int index)
		{
			return aps.get(index);
		}

		/**
		 * Gets the level.
		 *
		 * @param index the index
		 * @return the level
		 */
		public int getLevel(int index)
		{
			return level[index];
		}

		/**
		 * Gets the freq.
		 *
		 * @param index the index
		 * @return the freq
		 */
		public int getFreq(int index)
		{
			return freq[index];
		}

		/**
		 * Checks if is checked.
		 *
		 * @param index the index
		 * @return true, if is checked
		 */
		public boolean isChecked(int index){return checked[index];}

		/**
		 * Size.
		 *
		 * @return the int
		 */
		public int size(){return aps.size();}
	}

	/**
	 * The Class ScanResultLevelComparator.
	 */
	public static class ScanResultLevelComparator implements Comparator<ScanResult>
	{

		/* (non-Javadoc)
		 * @see java.util.Comparator#compare(java.lang.Object, java.lang.Object)
		 */
		public int compare(ScanResult a, ScanResult b){return b.level-a.level;}
	}

	/**
	 * The m sp.
	 * @uml.property  name="bSp"
	 * @uml.associationEnd  
	 */
	private Spinner bSp;

	/**
	 * The m sp.
	 * @uml.property  name="fSp"
	 * @uml.associationEnd  
	 */
	private Spinner	fSp;

	/**
	 * The m sp.
	 * @uml.property  name="rSp"
	 * @uml.associationEnd  
	 */
	private Spinner	rSp;

	/**
	 * The m sp.
	 * @uml.property  name="mSp"
	 * @uml.associationEnd  
	 */
	private Spinner	mSp;

	/**
	 * The aplist.
	 * @uml.property  name="nodes"
	 * @uml.associationEnd  
	 */
	private ListView nodes;

	/**
	 * The aplist.
	 * @uml.property  name="nodessel"
	 * @uml.associationEnd  
	 */
	private ListView	nodessel;

	/**
	 * The aplist.
	 * @uml.property  name="aplist"
	 * @uml.associationEnd  
	 */
	private ListView	aplist;

	/**
	 * The editnode.
	 * @uml.property  name="editnode"
	 * @uml.associationEnd  
	 */
	private ScrollView editnode;

	/**
	 * The et z.
	 * @uml.property  name="etName"
	 * @uml.associationEnd  
	 */
	private EditText etName;

	/**
	 * The et z.
	 * @uml.property  name="etDesc"
	 * @uml.associationEnd  
	 */
	private EditText	etDesc;

	/**
	 * The et z.
	 * @uml.property  name="etX"
	 * @uml.associationEnd  
	 */
	private EditText	etX;

	/**
	 * The et z.
	 * @uml.property  name="etY"
	 * @uml.associationEnd  
	 */
	private EditText	etY;

	/**
	 * The et z.
	 * @uml.property  name="etZ"
	 * @uml.associationEnd  
	 */
	private EditText	etZ;

	/**
	 * The node cursor.
	 * @uml.property  name="buildingCursor"
	 * @uml.associationEnd  
	 */
	private Cursor buildingCursor;

	/**
	 * The node cursor.
	 * @uml.property  name="floorCursor"
	 * @uml.associationEnd  
	 */
	private Cursor	floorCursor;

	/**
	 * The node cursor.
	 * @uml.property  name="roomCursor"
	 * @uml.associationEnd  
	 */
	private Cursor	roomCursor;

	/**
	 * The node cursor.
	 * @uml.property  name="nodeCursor"
	 * @uml.associationEnd  
	 */
	private Cursor	nodeCursor;

	/**
	 * The nodelink.
	 * @uml.property  name="apaction"
	 * @uml.associationEnd  
	 */
	private Button apaction;

	/**
	 * The nodelink.
	 * @uml.property  name="nodelink"
	 * @uml.associationEnd  
	 */
	private Button	nodelink;

	/**
	 * The approgr.
	 * @uml.property  name="approgr"
	 * @uml.associationEnd  
	 */
	private ProgressBar approgr;

	/**
	 * The delete node uri.
	 * @uml.property  name="nodeUri"
	 * @uml.associationEnd  
	 */
	private Uri nodeUri;

	/**
	 * The delete node uri.
	 * @uml.property  name="nodesUri"
	 * @uml.associationEnd  
	 */
	private Uri	nodesUri;

	/**
	 * The delete node uri.
	 * @uml.property  name="deleteNodeUri"
	 * @uml.associationEnd  
	 */
	private Uri	deleteNodeUri;

	/**
	 * The ad.
	 * @uml.property  name="nodeApAdapter"
	 * @uml.associationEnd  
	 */
	private ApListCursorAdapter nodeApAdapter;

	/**
	 * The ad.
	 * @uml.property  name="ad"
	 * @uml.associationEnd  
	 */
	private ApListCursorAdapter	ad;

	/**
	 * The selnod adapter.
	 * @uml.property  name="selnodAdapter"
	 * @uml.associationEnd  
	 */
	private SelNodesCursorAdapter selnodAdapter;

	/**
	 * The nodes adapter.
	 * @uml.property  name="nodesAdapter"
	 * @uml.associationEnd  
	 */
	private SimpleCursorAdapter nodesAdapter;

	/**
	 * The CL_MODE_DISPLAY.
	 * @uml.property  name="eDIT"
	 */
	private final short CL_MODE_EDIT=0;

	/**
	 * The CL_MODE_DISPLAY.
	 * @uml.property  name="sELECT"
	 */
	private final short	CL_MODE_SELECT=1;

	/**
	 * The CL_MODE_DISPLAY.
	 * @uml.property  name="dISPLAY"
	 */
	private final short	CL_MODE_DISPLAY=2;

	/**
	 * The click mode.
	 * @uml.property  name="clickMode"
	 */
	private short clickMode=CL_MODE_EDIT;

	/**
	 * The room_id.
	 * @uml.property  name="building_id"
	 */
	private long building_id=0;

	/**
	 * The room_id.
	 * @uml.property  name="floor_id"
	 */
	private long	floor_id=0;

	/**
	 * The room_id.
	 * @uml.property  name="room_id"
	 */
	private long	room_id=0;

	/**
	 * The known a ps.
	 * @uml.property  name="knownAPs"
	 * @uml.associationEnd  multiplicity="(0 -1)"
	 */
	private Ap[] knownAPs;

	/**
	 * The node_aps.
	 * @uml.property  name="node_aps"
	 * @uml.associationEnd  multiplicity="(0 -1)" elementType="android.net.wifi.ScanResult"
	 */
	private ArrayList<ScanResult> node_aps=new ArrayList<ScanResult>();

	/**
	 * The aps index.
	 * @uml.property  name="apsIndex" multiplicity="(0 -1)" dimension="1"
	 */
	private int[] apsIndex;

	/**
	 * The aplist edited.
	 * @uml.property  name="aplistEdited"
	 */
	private boolean aplistEdited=false;

	/** The neightbors edited. */
	private boolean somethingEdited=false;

	/**
	 * The wi man.
	 * @uml.property  name="wiMan"
	 * @uml.associationEnd  
	 */
	private WifiManager wiMan;

	/**
	 * The WIF i_ wifi.
	 * @uml.property  name="wIFI_NONE"
	 */
	private final short WIFI_NONE=0;

	/**
	 * The WIF i_ wifi.
	 * @uml.property  name="wIFI_NODE"
	 */
	private final short	WIFI_NODE=1;

	/**
	 * The WIF i_ wifi.
	 * @uml.property  name="wIFI_WIFI"
	 */
	private final short	WIFI_WIFI=2;

	/**
	 * The receive_for.
	 * @uml.property  name="receive_for"
	 */
	private short receive_for=WIFI_NONE;

	/** The dodelete. */
	private static boolean dodelete=false;

	/**
	 * The receiver.
	 * @uml.property  name="receiver"
	 * @uml.associationEnd  multiplicity="(1 1)"
	 */
	private BroadcastReceiver receiver=new BroadcastReceiver()
	{
		@Override
		public void onReceive(Context context, Intent intent)
		{
			IndMap.log(IndMap.DEBUG, TAG, "**Got Scanresult********************");
			List<ScanResult> srs=wiMan.getScanResults();
			Collections.sort(srs,new ScanResultLevelComparator());

			switch(receive_for)
			{
				case WIFI_NODE:
					receive_for=WIFI_NONE;
					updateNodeApListByScan(srs);
					break;						
				case WIFI_WIFI:
					receive_for=WIFI_NONE;
					listAvailableAPs(srs);
					break;
			}
		}
	};

	/**
	 * Inits the nodelist.
	 *
	 * @param data the data
	 */
	private void initNodelist(Bundle data)
	{
		try
		{
			//Componentes
			nodes=(ListView) findViewById(R.id.nodelist);
			bSp=(Spinner) findViewById(R.id.building);
			rSp=(Spinner) findViewById(R.id.room);
			fSp=(Spinner) findViewById(R.id.floor);

			//Onclicklisteners
			registerForContextMenu(nodes);
			nodes.setOnItemClickListener(new OnItemClickListener()
			{
				public void onItemClick(AdapterView<?> parent, View view, int position, long id)
				{
					switch (clickMode)
					{
						case CL_MODE_SELECT:
							selectNode(id);
							break;
						case CL_MODE_DISPLAY:
							displayNode(id);
							break;
						default:
							editNode(id);
					}
				}
			});
			/*nodes.setOnItemLongClickListener(new OnItemLongClickListener()
			{
				public boolean onItemLongClick(AdapterView<?> parent, View view, int position, long id)
				{
					//TODO Create Contextmenu
					return true;
				}
			});*/

			//Assign ItemSelectedListeners
			bSp.setOnItemSelectedListener(new OnItemSelectedListener(){
				public void onItemSelected(AdapterView<?> parent, View v, int pos, long row)
				{
					updateBuildingSpinner(row);
				}
				public void onNothingSelected(AdapterView<?> parent){}
			});

			//Assign data building spinner
			MatrixCursor mc=new MatrixCursor(Building.Entety.PROJ_ALL); //Dummy p toppen av lista
			mc.addRow(Building.Entety.SPINNER_TEXT_ALL);
			buildingCursor=new MergeCursor(new Cursor[]{
					mc,
					managedQuery(Uri.withAppendedPath(Provider.CONTENT_URI, Building.TABLE_NAME), null, null, null, null)
			});
			bSp.setAdapter(new SimpleCursorAdapter(this,
					R.layout.list_id_name_item,
					buildingCursor,new String[]{Building.ID,Building.NAME}, new int[] {R.id.id,R.id.name})
			);
			//Do preselections
			if(data!=null&&data.containsKey(Building.PARENT)) //Building is given, find witch item to select
			{
				selectBuildingByID(data.getInt(Building.PARENT));
				if(data.containsKey(Floor.PARENT))
				{
					selectFloorByID(data.getInt(Floor.PARENT));
					if(data.containsKey(Room.PARENT))
					{
						selectRoomByID(data.getInt(Room.PARENT));
					}
					else updateNodelist(floor_id, Floor.TABLE_NAME);
				}
				else updateNodelist(building_id, Building.TABLE_NAME);
			}
			else updateNodelist(0, "");
		}catch (Exception e)
		{
			IndMap.log(IndMap.ERROR, TAG, "initNodelist "+e.toString());
		}
	}

	/**
	 * Inits the selected nodes.
	 *
	 * @param b the b
	 */
	private void initSelectedNodes(Bundle b)
	{
		try
		{
			nodessel=(ListView) findViewById(R.id.nodeselected);
			registerForContextMenu(nodessel);

			OnItemClickListener oicl=new OnItemClickListener()
			{

				public void onItemClick(AdapterView<?> parent, View view, int position, long id)
				{
					IndMap.log(IndMap.DEBUG, TAG, "SelNodesList onclick: mode: "+clickMode+" id: "+id);
					switch (clickMode)
					{
						case CL_MODE_SELECT:
							unSelectNode(id);
							break;
						case CL_MODE_DISPLAY:
							displayNode(id);
							break;
						default:
							if(id!=selnodAdapter.getParent())editNode(id);
					}
				}
			};
			OnLongClickListener olcl=new OnLongClickListener() {

				public boolean onLongClick(View v)
				{
					registerForContextMenu(nodessel);
					nodessel.showContextMenu();
					return true;
				}
			};

			selnodAdapter=new SelNodesCursorAdapter(getApplicationContext(), R.layout.node_sel_par_item, SelNodesCursorAdapter.SEL_MODE_NONE, -1,oicl,olcl);
			nodessel.setAdapter(selnodAdapter);

			nodessel.setOnItemClickListener(oicl);

			//After save link mode
			Spinner nodemode = (Spinner) findViewById(R.id.node_mode);
			nodemode.setAdapter(ArrayAdapter.createFromResource(this, R.array.node_mode, android.R.layout.simple_spinner_item));
			nodemode.setSelection(SelNodesCursorAdapter.SEL_MODE_NONE);
			nodemode.setOnItemSelectedListener(new OnItemSelectedListener() {

				public void onItemSelected(AdapterView<?> parent, View v, int pos, long row)
				{
					selnodAdapter.setNodeMode((short) pos);
				}
				public void onNothingSelected(AdapterView<?> arg0)
				{}
			});

			//Chose linkmode
			mSp= (Spinner) findViewById(R.id.node_sel_mode);
			mSp.setAdapter(ArrayAdapter.createFromResource(this, R.array.node_sel_mode, android.R.layout.simple_spinner_item));
			mSp.setSelection(SelNodesCursorAdapter.DISP_MODE_ROUTE);
			mSp.setOnItemSelectedListener(new OnItemSelectedListener() {

				public void onItemSelected(AdapterView<?> parent, View v, int pos, long row)
				{
					selnodAdapter.setListMode(NodeActivity.this, (short)pos);
					updNodeSel();
				}
				public void onNothingSelected(AdapterView<?> arg0)
				{}
			});

			nodelink=(Button) findViewById(R.id.dolink);
			nodelink.setOnClickListener(new OnClickListener()
			{
				public void onClick(View v)
				{
					selnodAdapter.saveAndGetNodeId(NodeActivity.this);
					updNodeSel();
					somethingEdited=true;
				}
			});

		}catch (Exception e) {
			IndMap.log(IndMap.ERROR, TAG, "initSelectedNodes "+e.toString());
		}
	}

	/**
	 * Inits the edit node.
	 *
	 * @param data the data
	 */
	private void initEditNode(Bundle data)
	{
		try{
			//Componentes
			editnode=(ScrollView) findViewById(R.id.node_editor);
			etName=(EditText) findViewById(R.id.node_name);
			etDesc=(EditText) findViewById(R.id.node_desc);
			etX=(EditText) findViewById(R.id.node_x);
			etY=(EditText) findViewById(R.id.node_y);
			etZ=(EditText) findViewById(R.id.node_z);
			aplist=(ListView) findViewById(R.id.node_aplist);

			//ASSIGN BUTTONS

			//NEW BUTTON
			((Button) findViewById(R.id.donew)).setOnClickListener(new OnClickListener()
			{
				public void onClick(View v){editNode(0);}
			});
			//DELETE BUTTON
			((Button) findViewById(R.id.dodel)).setOnClickListener(new OnClickListener()
			{
				public void onClick(View v)
				{
					getContentResolver().delete(nodeUri,null, null);
					editnode.setVisibility(View.INVISIBLE);
					((Button) findViewById(R.id.dodel)).setVisibility(View.GONE);
					((Button) findViewById(R.id.dosave)).setVisibility(View.GONE);
					updateNodelist(nodesUri);
					nodeUri=null;
				}
			});
			//SAVE BUTTON
			((Button) findViewById(R.id.dosave)).setOnClickListener(new OnClickListener()
			{
				public void onClick(View v)
				{
					//TODO validering
					deleteNodeUri=null;
					somethingEdited=true;
					String node_id=nodeUri.getPathSegments().get(1);

					ContentValues values=new ContentValues();
					values.put(Node.X,etX.getText().toString());
					values.put(Node.Y,etY.getText().toString());
					values.put(Node.Z,etZ.getText().toString());
					String name=etName.getText().toString();
					values.put(Node.NAME,name);
					String desc=etDesc.getText().toString();
					if(desc.length()<2)desc=name;
					values.put(Node.DESC,desc);
					if(building_id>0)values.put(Building.PARENT,building_id);
					if(floor_id>0)values.put(Floor.PARENT,floor_id);
					if(room_id>0)values.put(Room.PARENT,room_id);

					editnode.setVisibility(View.INVISIBLE);
					((Button) findViewById(R.id.dodel)).setVisibility(View.GONE);
					((Button) findViewById(R.id.dosave)).setVisibility(View.GONE);

					try{getContentResolver().update(nodeUri, values, null, null);}
					catch (Exception e)
					{
						Toast.makeText(getApplicationContext(), "Could not save. Probably error in fields!", Toast.LENGTH_LONG).show();
						return;
					}

					if(aplistEdited) //Do not need to save aplist if not modified
					{
						//Reset record of aps for node. Exception if not exist before this
						try{getContentResolver().delete(Uri.withAppendedPath(Provider.CONTENT_URI,Ap.TABLE_NAME+Node.TABLE_NAME+"/"+node_id), null, null);}catch (Exception e) {

						}

						//Insert new record
						for(int i=0;i<node_aps.size();i++)
						{
							ScanResult sr=node_aps.get(i);
							values=new ContentValues();
							values.put(Ap.PARENT, apsIndex[i]);
							values.put(Node.PARENT, node_id);
							values.put(Ap.LEVELatNODE, sr.level);
							try{getContentResolver().insert(Uri.withAppendedPath(Provider.CONTENT_URI,Ap.TABLE_NAME+Node.TABLE_NAME), values);}
							catch (Exception e)
							{
								Toast.makeText(getApplicationContext(), "Could not save AP-list.", Toast.LENGTH_LONG).show();
								IndMap.log(IndMap.ERROR, TAG, "Error inserting APlist to db "+e.toString());
								return;
							}
						}
					}
					Toast.makeText(getApplicationContext(), "Node Saved!", Toast.LENGTH_LONG).show();
					//nodeCursor.requery();
					nodeUri=null;
					updateNodelist(nodesUri);
					updateSelectedNodes(-1);
				}
			});
			//WIFI PROFILE BUTTON
			apaction=(Button) findViewById(R.id.doapprof);
			apaction.setOnClickListener(new OnClickListener()
			{
				public void onClick(View v){scan(WIFI_NODE);}
			});
			//WIFI SCAN PROGRESSBAR
			approgr=(ProgressBar) findViewById(R.id.approgress);

			//AP make/update PROFILE
			if(data!=null&&data.containsKey(Node.X)&&data.containsKey(Node.Y)&&data.containsKey(Node.Z))
			{
				try
				{
					ContentValues val=new ContentValues();
					val.put(Node.X, data.getFloat(Node.X));
					val.put(Node.Y, data.getFloat(Node.Y));
					val.put(Node.Z, data.getFloat(Node.Z));
					nodeUri=getContentResolver().insert(Uri.withAppendedPath(Provider.CONTENT_URI, Node.TABLE_NAME), val);
					deleteNodeUri=nodeUri;
					editNode(nodeUri);
				}catch (Exception e) {
					IndMap.log(IndMap.ERROR, TAG, "load x,y,z "+e.toString());
				}
			}
		}catch (Exception e) {
			IndMap.log(IndMap.ERROR, TAG, "initEditNode "+e.toString());
		}
	}

	/**
	 * Edits the node.
	 *
	 * @param id the id
	 */
	private void editNode(long id)
	{
		try{
			Uri uri=Uri.withAppendedPath(Provider.CONTENT_URI, Node.TABLE_NAME);
			if(id<1)
			{
				//Make new node, and get uri to update
				uri=getContentResolver().insert(uri, null);
				deleteNodeUri=uri;
			}
			else uri=ContentUris.withAppendedId(uri,id);
			editNode(uri,id);
		}catch (Exception e) {
			IndMap.log(IndMap.ERROR, TAG, "editnode "+e.toString());
		}
	}

	/**
	 * Edits the node.
	 *
	 * @param uri the uri
	 * @param id the id
	 */
	private void editNode(Uri uri,long id)
	{
		if(uri==null)
		{
			IndMap.log(IndMap.ERROR, TAG, "Edit node uri null");
			return;
		}
		try
		{
			nodeUri=uri;
			Cursor c=nodeCursor=managedQuery(nodeUri,null,null,null,null);
			//TODO kan nodeCursor droppes som private field?

			c.moveToFirst();
			etName.setText(c.getString(c.getColumnIndex(Node.NAME)));
			etDesc.setText(c.getString(c.getColumnIndex(Node.DESC)));
			etX.setText(c.getString(c.getColumnIndex(Node.X)));
			etY.setText(c.getString(c.getColumnIndex(Node.Y)));
			etZ.setText(c.getString(c.getColumnIndex(Node.Z)));

			editnode.setVisibility(View.VISIBLE);
			editnode.scrollTo(0,0);
			((Button) findViewById(R.id.dodel)).setVisibility(View.VISIBLE);
			((Button) findViewById(R.id.dosave)).setVisibility(View.VISIBLE);

			c=getContentResolver().query(Uri.withAppendedPath(Provider.CONTENT_URI,Ap.TABLE_NAME+Node.TABLE_NAME+"/"+id), null, null, null, null);
			nodeApAdapter=new ApListCursorAdapter(getApplicationContext(), R.layout.aplist_ttp_item, c, knownAPs, false);
			aplistEdited=false;

			updateSelectedNodes(id);
			setAplist();
			c.close();
		}catch (Exception e) {
			IndMap.log(IndMap.ERROR, TAG, "editnode by uri+long "+e.toString());
		}
	}

	/**
	 * Edits the node.
	 *
	 * @param uri the uri
	 */
	private void editNode(Uri uri)
	{
		if(uri.getPathSegments().size()>0)editNode(uri, Long.valueOf(uri.getPathSegments().get(1)));
	}

	/**
	 * Update selected nodes.
	 *
	 * @param parent_id the parent_id
	 */
	private void updateSelectedNodes(long parent_id)
	{
		selnodAdapter.setParent((int) parent_id);
		updNodeSel();
	}

	/**
	 * Select node.
	 *
	 * @param id the id
	 */
	private void selectNode(long id)
	{
		try{
			selnodAdapter.add(NodeActivity.this, (int)id);
		}catch (Exception e) {
			Toast.makeText(getApplicationContext(), e.toString(), Toast.LENGTH_LONG).show();
		}
		updNodeSel();
	}

	/**
	 * Un select node.
	 *
	 * @param id the id
	 */
	private void unSelectNode(long id)
	{
		selnodAdapter.remove((int)id);
		updNodeSel();
	}

	/**
	 * Upd node sel.
	 */
	private void updNodeSel()
	{
		nodessel.setAdapter(selnodAdapter);
		switch(selnodAdapter.getListMode())
		{
			case SelNodesCursorAdapter.DISP_MODE_PARENT:
				if(selnodAdapter.size()>0)nodelink.setVisibility(View.VISIBLE);
				else nodelink.setVisibility(View.INVISIBLE);
				mSp.setSelection(SelNodesCursorAdapter.DISP_MODE_PARENT);
				break;
			case SelNodesCursorAdapter.DISP_MODE_ROUTE:
				if(selnodAdapter.size()>1)nodelink.setVisibility(View.VISIBLE);
				else nodelink.setVisibility(View.INVISIBLE);
				mSp.setSelection(SelNodesCursorAdapter.DISP_MODE_ROUTE);
				break;
		}
		if(selnodAdapter.size()>0)
		{
			if(selnodAdapter.getParent()<0)mSp.setVisibility(View.INVISIBLE);
			else mSp.setVisibility(View.VISIBLE);
		}
	}

	/**
	 * Display node.
	 *
	 * @param id the id
	 */
	private void displayNode(long id)
	{
		IndMap.log(IndMap.DEBUG, TAG, "Display node!");
		Intent i=new Intent(getApplicationContext(), IndMap.class);
		i.putExtra("viewNode",(int) id);
		startActivity(i);
	}

	/**
	 * Sets the aplist.
	 */
	private void setAplist()
	{
		aplist.setAdapter(nodeApAdapter);
		//		IndMap.log(IndMap.DEBUG, TAG, "Got Ap's for node: "+nodeApAdapter.getCount());

		if(nodeApAdapter.getCount()>0)apaction.setText(R.string.doupd);
		else apaction.setText(R.string.domake);
	}

	/**
	 * Scan.
	 *
	 * @param for_what the for_what
	 */
	private void scan(final short for_what)
	{
		if(wiMan!=null)
		{
			if(for_what==WIFI_NODE)
			{
				approgr.setVisibility(View.VISIBLE);
				apaction.setVisibility(View.GONE);
			}
			receive_for=for_what;
			wiMan.startScan();
			IndMap.log(IndMap.DEBUG, TAG, "Wifi start scanning #"+receive_for);
		}
		else 
		{
			Toast.makeText(this, "Can't access Wifi device", Toast.LENGTH_LONG).show();
			IndMap.log(IndMap.ERROR, TAG, "Wifi not accessable");
		}
	}

	/**
	 * Update node ap list by scan.
	 *
	 * @param srs the srs
	 */
	private void updateNodeApListByScan(List<ScanResult> srs)
	{
		Iterator<ScanResult> i=srs.iterator();
		//Assigns AP-profile for a node (have to click save, to save with node in database)
		//{ Ap._ID, Ap.NAME, Ap.BSSID, Ap.LEVELatNODE }
		node_aps=new ArrayList<ScanResult>();
		//						nodeApCursor=new MatrixCursor(Ap.Entety.PROJ_NODE_ALL);
		IndMap.log(IndMap.DEBUG, TAG, "** num KnownAps: "+knownAPs.length);
		int n=0;
		ArrayList<Integer> apIndex=new ArrayList<Integer>(srs.size());
		if(i!=null)while(i.hasNext())
		{
			ScanResult sr=i.next();
			IndMap.log(IndMap.DEBUG, TAG, "** Found: "+sr.toString());
			Ap ap=Ap.getApByBSSID(knownAPs, Ap.stringSSID2long(sr.BSSID, Ap.BSSID_SEPERATOR));
			if(ap!=null&&sr.level>Node.MIN_SIGNAL)
			{
				if(n>Node.MAX_NUM_APS)break;
				IndMap.log(IndMap.DEBUG, TAG, "  - #"+n+" Added to list!");
				node_aps.add(sr);
				apIndex.add(new Integer(ap.getI()));
				n++;
			}
		}
		apsIndex=new int[apIndex.size()];
		for(int j=0;j<apIndex.size();j++)apsIndex[j]=apIndex.get(j);
		nodeApAdapter=new ApListCursorAdapter(getApplicationContext(), R.layout.aplist_ttp_item, node_aps, knownAPs, false,false);

		approgr.setVisibility(View.GONE);
		apaction.setVisibility(View.VISIBLE);
		aplistEdited=true;
		setAplist();
	}

	/**
	 * List available a ps.
	 *
	 * @param srs the srs
	 */
	private void listAvailableAPs(List<ScanResult> srs)
	{
		if(srs.size()>0)
		{
			ad=new ApListCursorAdapter(getApplicationContext(), R.layout.aplist_sttp_item, srs, knownAPs, ApListCursorAdapter.SELECT_VIEW,false);
			final Dialog d=new Dialog(NodeActivity.this);
			d.setContentView(R.layout.ap_list);
			d.setTitle(R.string.ap_title);
			ListView lv=(ListView) d.findViewById(R.id.list);
			lv.setAdapter(ad);
			//lv.setAdapter(new ArrayAdapter<String>(NodeActivity.this, R.layout.list_textview, aPs));

			Button save=(Button) d.findViewById(R.id.save);
			save.setOnClickListener(new OnClickListener()
			{
				public void onClick(View v)
				{
					boolean changes=false;
					dodelete=false;
					for(int i=0;i<ad.getCount();i++)
					{
						int id=ad.getAp(i).getI();
						boolean check=ad.isChecked(i);
						if(id<0&&check)
						{
							changes=true;
							IndMap.log(IndMap.DEBUG, TAG, "Wifi Inserting new AP: "+ad.getAp(i).toString());
							ContentValues val=new ContentValues();
							val.put(Ap.NAME, ad.getSSID(i));
							val.put(Ap.BSSID, ad.getBssidString(i));
							try{getContentResolver().insert(Uri.withAppendedPath(Provider.CONTENT_URI, Ap.TABLE_NAME), val);}
							catch (Exception e) {IndMap.log(IndMap.ERROR, TAG, "Insert Ap "+e.toString());}
						}
						if(id>0&&!check)
						{
							if(!dodelete)
							{
								AlertDialog.Builder builder = new AlertDialog.Builder(NodeActivity.this);
								builder.setMessage("Want to delete "+ad.getAp(i).toString()+"Continue?")
								.setCancelable(true)
								.setPositiveButton("Yes", new DialogInterface.OnClickListener()
								{
									public void onClick(DialogInterface dialog, int id)
									{
										dodelete=true;
										dialog.cancel();
									}
								})
								.setNegativeButton("No", new DialogInterface.OnClickListener()
								{

									public void onClick(DialogInterface dialog, int which)
									{
										dialog.cancel();
									}
								});
								AlertDialog alert = builder.create();
								alert.show();
							}
							if(dodelete)
							{
								changes=true;
								IndMap.log(IndMap.DEBUG, TAG, "Wifi deleting AP: "+ad.getAp(i).toString());
								try{getContentResolver().delete(Uri.withAppendedPath(Provider.CONTENT_URI, Ap.TABLE_NAME+"/"+id), null, null);}
								catch (Exception e) {IndMap.log(IndMap.ERROR, TAG, "Delete Ap "+e.toString());}
							}
						}
					}
					d.dismiss();
					Toast.makeText(getApplicationContext(), "Saved changes!", Toast.LENGTH_LONG);
					if(changes)
					{
						ArrayList<Ap> a=new ArrayList<Ap>();
						Cursor c=getContentResolver().query(Uri.withAppendedPath(Provider.CONTENT_URI, Ap.TABLE_NAME+"/bybssid"), null,null,null,null);
						if(c.moveToFirst())	do {a.add(new Ap(c)); }while(c.moveToNext());
						knownAPs=new Ap[a.size()];
						a.toArray(knownAPs);
						c.close();
					}
					ad=null;
				}
			});

			Button cancel=(Button) d.findViewById(R.id.cancel);
			cancel.setOnClickListener(new OnClickListener()
			{
				public void onClick(View v)
				{
					d.dismiss();
				}
			});
			d.show();
		}
	}


	/* (non-Javadoc)
	 * @see android.app.Activity#onCreate(android.os.Bundle)
	 */
	public void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.node_main);
		wiMan=(WifiManager) getSystemService(WIFI_SERVICE);
		if(wiMan==null)IndMap.log(IndMap.ERROR, TAG, "Wifi not accessable");

		SharedPreferences set = getSharedPreferences(PREFERENCES, 0);
		clickMode=(short) set.getInt("clMode",CL_MODE_EDIT);

		ArrayList<Ap> a=new ArrayList<Ap>(50);
		Cursor c=getContentResolver().query(Uri.withAppendedPath(Provider.CONTENT_URI, Ap.TABLE_NAME+"/bybssid"), null,null,null,null);
		if(c.moveToFirst())	do {a.add(new Ap(c)); }while(c.moveToNext());
		knownAPs=new Ap[a.size()];
		a.toArray(knownAPs);

		final Intent intent=getIntent();
		final Bundle b=intent.getExtras();
		initNodelist(b);
		initSelectedNodes(b);
		initEditNode(b);
		if(b.containsKey("atNode"))
		{
			nodeUri=intent.getData();
			editNode(nodeUri);
		}
		c.close();

		//clickMode
	}

	/* (non-Javadoc)
	 * @see android.app.Activity#onResume()
	 */
	@Override
	protected void onResume()
	{
		super.onResume();
		registerReceiver(receiver, new IntentFilter(WifiManager.SCAN_RESULTS_AVAILABLE_ACTION));
	}

	@Override
	public void onBackPressed()
	{
		if(nodeUri!=null)
		{
			setResult(RESULT_OK, new Intent(Intent.ACTION_VIEW).setData(nodeUri));
			IndMap.log(IndMap.DEBUG, TAG, "Returning: "+nodeUri.toString());	
		}
		else if(somethingEdited)
		{
			setResult(RESULT_OK);
		}
		super.onBackPressed();
	}
	
	@Override
	protected void onPause()
	{
		super.onPause();

		SharedPreferences set = getSharedPreferences(PREFERENCES, 0);
		SharedPreferences.Editor e = set.edit();
		e.putInt("clMode", clickMode);
		e.commit();

		unregisterReceiver(receiver);
		
		if(deleteNodeUri!=null)
		{
			getContentResolver().delete(deleteNodeUri,null, null);
			IndMap.log(IndMap.DEBUG, TAG, "Deleted node: "+deleteNodeUri.toString());
		}
		closeCursors();
	}

	/**
	 * Update nodelist.
	 *
	 * @param parent_id the parent_id
	 * @param uriPath the uri path
	 */
	private void updateNodelist(long parent_id,String uriPath)
	{
		updateNodelist(Uri.withAppendedPath(Provider.CONTENT_URI, Node.TABLE_NAME+uriPath+(parent_id>0?"/"+parent_id:"null")));
	}

	/**
	 * Update nodelist.
	 *
	 * @param uri the uri
	 */
	private void updateNodelist(Uri uri)
	{
		/*URIs
		 * node
		 * nodebuilding/#
		 * nodefloor/#
		 * noderoom/#
		 */
		try
		{
			nodesUri=uri;
			nodesAdapter=new SimpleCursorAdapter(this,
					R.layout.node_item,
					managedQuery(uri, null, null, null, null),
					new String[]{Node._ID,Node.NAME,Node.DESC}, new int[] {R.id.id,R.id.name,R.id.desc}
			);
			nodes.setAdapter(nodesAdapter);
			//			IndMap.log(IndMap.DEBUG, TAG, "Update nodeview, uri: '"+uri+"'");
		}catch (Exception e)
		{
			IndMap.log(IndMap.ERROR, TAG, "updateNodelist"+e.toString());
			return;
		}
	}

	/**
	 * Update room spinner.
	 *
	 * @param room_id the room_id
	 */
	private void updateRoomSpinner(long room_id)
	{
		this.room_id=room_id;
		try{
			//this.room_id=room_id;
			if(room_id<1)
			{
				updateNodelist(floor_id, Floor.TABLE_NAME);
			}
			else
			{
				updateNodelist(room_id, Room.TABLE_NAME);
			}
		}catch (Exception e)
		{
			IndMap.log(IndMap.ERROR, TAG, "updateRoomSpinner"+e.toString());
		}
	}

	/**
	 * Select room by id.
	 *
	 * @param room_id the room_id
	 */
	private void selectRoomByID(long room_id)
	{
		updateRoomSpinner(room_id);
		for(int i=1;i<roomCursor.getCount();i++)
		{
			roomCursor.moveToPosition(i);				
			if(roomCursor.getInt(roomCursor.getColumnIndex(Room._ID))==room_id)
			{
				rSp.setSelection(i);
				break;
			}
		}
	}

	/**
	 * Update floor spinner.
	 *
	 * @param floor_id the floor_id
	 */
	private void updateFloorSpinner(long floor_id)
	{
		try{
			this.floor_id=floor_id;
			if(floor_id<1) //Deaktivate room-spinner, load nodes given floor
			{
				rSp.setOnItemSelectedListener(null);
				rSp.setVisibility(View.INVISIBLE);
				updateNodelist(building_id, Building.TABLE_NAME);
			}
			else
			{
				MatrixCursor mc=new MatrixCursor(Room.Entety.PROJ_ALL); //Dummy p toppen av lista
				mc.addRow(Room.Entety.SPINNER_TEXT_ALL);

				roomCursor=new MergeCursor(new Cursor[]{
						mc,
						getContentResolver().query(Uri.withAppendedPath(Provider.CONTENT_URI,Floor.TABLE_NAME+Room.TABLE_NAME+"/"+floor_id), null, null, null, null)
				});
				rSp.setAdapter(new SimpleCursorAdapter(this,
						R.layout.list_id_name_item,
						roomCursor,
						new String[]{Room.ID,Room.NAME}, new int[] {R.id.id,R.id.name}));
				rSp.setOnItemSelectedListener(new OnItemSelectedListener(){
					public void onItemSelected(AdapterView<?> parent, View v, int pos, long row)
					{
						updateRoomSpinner(row);
					}
					public void onNothingSelected(AdapterView<?> parent){}
				});

				rSp.setVisibility(View.VISIBLE);
				updateNodelist(floor_id, Floor.TABLE_NAME);
			}
		}catch (Exception e)
		{
			IndMap.log(IndMap.ERROR, TAG, "updateFloorSpinner"+e.toString());
		}
	}

	/**
	 * Select floor by id.
	 *
	 * @param floor_id the floor_id
	 */
	private void selectFloorByID(long floor_id)
	{
		updateFloorSpinner(floor_id);
		for(int i=1;i<floorCursor.getCount();i++)
		{
			floorCursor.moveToPosition(i);				
			if(floorCursor.getInt(floorCursor.getColumnIndex(Floor._ID))==floor_id)
			{
				fSp.setSelection(i);
				break;
			}
		}
	}

	/**
	 * Update building spinner.
	 *
	 * @param building_id the building_id
	 */
	private void updateBuildingSpinner(long building_id)
	{
		try{
			this.building_id=building_id;
			if(building_id<1) //Deactivate floor-spinner, load all nodes without building  
			{
				fSp.setOnItemSelectedListener(null);
				fSp.setVisibility(View.INVISIBLE);
				rSp.setVisibility(View.INVISIBLE);
				updateNodelist(0, "");
			}
			else
			{
				MatrixCursor mc=new MatrixCursor(Floor.Entety.PROJ_ALL); //Dummy p toppen av lista
				mc.addRow(Floor.Entety.SPINNER_TEXT_ALL);

				floorCursor=new MergeCursor(new Cursor[]{
						mc,
						getContentResolver().query(Uri.withAppendedPath(Provider.CONTENT_URI, Building.TABLE_NAME+Floor.TABLE_NAME+"/"+building_id), null, null, null, null)
				});
				fSp.setAdapter(new SimpleCursorAdapter(this,
						R.layout.list_id_name_item,
						floorCursor,
						new String[]{Floor.ID,Floor.NAME}, new int[] {R.id.id,R.id.name}));
				fSp.setOnItemSelectedListener(new OnItemSelectedListener(){
					public void onItemSelected(AdapterView<?> parent, View v, int pos, long row)
					{
						updateFloorSpinner(row);
					}
					public void onNothingSelected(AdapterView<?> parent){}
				});

				fSp.setVisibility(View.VISIBLE);
				updateNodelist(building_id, Building.TABLE_NAME);
			}
		}catch (Exception e)
		{
			IndMap.log(IndMap.ERROR, TAG, "updateBuildingSpinner"+e.toString());
		}
	}

	/**
	 * Select building by id.
	 *
	 * @param building_id the building_id
	 */
	private void selectBuildingByID(long building_id)
	{
		updateBuildingSpinner(building_id);
		for(int i=1;i<buildingCursor.getCount();i++)
		{
			buildingCursor.moveToPosition(i);				
			if(buildingCursor.getInt(buildingCursor.getColumnIndex(Building._ID))==building_id)
			{
				bSp.setSelection(i);
				break;
			}
		}
	}

	/**
	 * Select click mode.
	 */
	public void selectClickMode()
	{
		AlertDialog.Builder bu = new AlertDialog.Builder(this);
		bu.setTitle("Pick a color");
		bu.setSingleChoiceItems(R.array.menu_clmodes, clickMode, new DialogInterface.OnClickListener()
		{
			public void onClick(DialogInterface d, int w)
			{
				clickMode=(short) w;
				d.dismiss();
			}
		});
		AlertDialog alert = bu.create();
		alert.show();
	}

	/* (non-Javadoc)
	 * @see android.app.Activity#onCreateOptionsMenu(android.view.Menu)
	 */
	@Override
	public boolean onCreateOptionsMenu(Menu menu)
	{
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.menu.node_options_menu, menu);

		menu.findItem(R.id.menu_clmode).getSubMenu().getItem(clickMode).setChecked(true);
		return true;
	}

	/* (non-Javadoc)
	 * @see android.app.Activity#onOptionsItemSelected(android.view.MenuItem)
	 */
	@Override
	public boolean onOptionsItemSelected(MenuItem item)
	{
		switch (item.getItemId())
		{
			case R.id.menu_getpos:
				scan(WIFI_WIFI);
				return true;
			case R.id.menu_neighbor:
				if(nodeUri!=null)
				{
					String node_id=nodeUri.getPathSegments().get(1);
					Cursor c=getContentResolver().query(Uri.withAppendedPath(Provider.CONTENT_URI, Node.TABLE_NAME+Node.TABLE_NAME+"/"+node_id), null, null, null, null);
					if(!c.moveToFirst())Toast.makeText(getApplicationContext(), "No neighbors found", Toast.LENGTH_LONG).show();
					else
					{
						selnodAdapter.removeAll();
						selnodAdapter.setListMode(getApplicationContext(), SelNodesCursorAdapter.DISP_MODE_PARENT);
						do
						{
							selnodAdapter.add(getApplicationContext(), c.getInt(c.getColumnIndex(Node._ID)));
						}while(c.moveToNext());
						updNodeSel();
					}
				}
				return true;
			case R.id.menu_sort:
				return true;
				//			case R.id.menu_clmode:
				//				selectClickMode();
				//				return true;
			case R.id.clmode0:
				clickMode=CL_MODE_EDIT;
				return true;
			case R.id.clmode1:
				clickMode=CL_MODE_SELECT;
				return true;
			case R.id.clmode2:
				clickMode=CL_MODE_DISPLAY;
				return true;
			default:
				return super.onOptionsItemSelected(item);
		}
	}

	/* (non-Javadoc)
	 * @see android.app.Activity#onCreateContextMenu(android.view.ContextMenu, android.view.View, android.view.ContextMenu.ContextMenuInfo)
	 */
	@Override
	public void onCreateContextMenu(ContextMenu menu, View v, ContextMenuInfo menuInfo)
	{
		super.onCreateContextMenu(menu, v, menuInfo);
		AdapterContextMenuInfo info = (AdapterContextMenuInfo) menuInfo; 
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.menu.node_context, menu);

		int id=-1;
		String name=null;

		if(v.getId()==nodessel.getId())
		{
			MenuItem mi=menu.findItem(R.id.menu_select);
			mi.setTitle(R.string.dounselect);
			mi.setIntent(new Intent(UNSELECT_ACTION));

			menu.add(0, R.id.doroute, 0, R.string.doroute);
			menu.add(0, R.id.doroutegen, 0, R.string.doroutegen);

			//Some extra stuff to avoid fucking editText and contextmenu super ugly hack workaround not making NullPointerException
			Node n=selnodAdapter.getNode((info!=null?info.position:-1));
			if(n!=null)
			{
				id=n.getI();
				name=n.getName();
			}
		}
		else
		{
			Cursor c=nodesAdapter.getCursor();
			c.moveToPosition(info.position);
			id=c.getInt(c.getColumnIndex(Node._ID));
			name=c.getString(c.getColumnIndex(Node.NAME));
		}

		//Some extra stuff to avoid fucking editText and contextmenu super fault, using ugly hack workaround not making NullPointerException
		if(name!=null)menu.setHeaderTitle(id+" - "+name);

		MenuItem mi=menu.findItem(R.id.menu_clmode);
		if(mi!=null)mi.getSubMenu().getItem(clickMode).setChecked(true);
	}

	/* (non-Javadoc)
	 * @see android.app.Activity#onContextItemSelected(android.view.MenuItem)
	 */
	@Override
	public boolean onContextItemSelected(MenuItem item)
	{
		Bundle b=new Bundle();
		AdapterContextMenuInfo info = (AdapterContextMenuInfo) item.getMenuInfo();
		switch (item.getItemId())
		{
			case R.id.menu_edit:
				editNode(info.id);
				return true;
			case R.id.menu_select:
				Intent i=item.getIntent();
				if(i!=null&&i.getAction().equals(UNSELECT_ACTION))unSelectNode(info.id);
				else selectNode(info.id);
				return true;
			case R.id.menu_display:
				displayNode(info.id);
				return true;
				//			case R.id.menu_clmode:
				//				selectClickMode();
				//				return true;
			case R.id.doroute:
				b.putIntArray("asRoute", selnodAdapter.getSelectedById());
				startActivity(new Intent(getApplicationContext(), IndMap.class).putExtras(b));
				//				finishAndResult(4321,b);
				return true;
			case R.id.doroutegen:
				b.putIntArray("makeRoute", selnodAdapter.getSelectedById());
				startActivity(new Intent(getApplicationContext(), IndMap.class).putExtras(b));
				//				finishAndResult(4321,b);
				return true;
			case R.id.menu_view:
				IndMap.log(IndMap.DEBUG, TAG, "SEND:   -viewNode: "+info.id);
				b.putInt("viewNode", (int) info.id);
				//startActivity(new Intent(getApplicationContext(), IndMap.class).putExtras(b));
				finishAndResult(4321,b);
				return true;
			case R.id.clmode0:
				clickMode=CL_MODE_EDIT;
				return true;
			case R.id.clmode1:
				clickMode=CL_MODE_SELECT;
				return true;
			case R.id.clmode2:
				clickMode=CL_MODE_DISPLAY;
				return true;
			default:
				return super.onContextItemSelected(item);
		}
	}

	/**
	 * Finish and result.
	 *
	 * @param code the code
	 * @param b the b
	 */
	private void finishAndResult(int code, Bundle b)
	{
		Intent i=new Intent(getApplicationContext(), IndMap.class);
		i.putExtras(b);
		closeCursors();
		setResult(RESULT_FIRST_USER, i);
		finish();
	}

	/**
	 * Close cursors.
	 */
	private void closeCursors()
	{
		SharedPreferences set = getSharedPreferences(PREFERENCES, 0);
		SharedPreferences.Editor e = set.edit();
		e.putInt("clMode", clickMode);

		if(nodeCursor!=null)nodeCursor.close();
		if(floorCursor!=null)floorCursor.close();
		if(roomCursor!=null)roomCursor.close();		
	}
}
