/*
 * 
 */
package no.ntnu.map.indoormaps;

// TODO: Auto-generated Javadoc
/**
 * The Class Point.
 */
public class Point
{
	public static final String TAG="Point";

	/**
	 * The Class RotatePoint.
	 */
	public static class RotatePoint extends Point
	{

		/** The rotate_x. */
		public float rotate_x=0.0f;

		/** The rotate_y. */
		public float rotate_y=0.0f;

		/** The rotate_z. */
		public float rotate_z=0.0f;

		/**
		 * Instantiates a new rotate point.
		 *
		 * @param x the x
		 * @param y the y
		 * @param z the z
		 * @param rot_x the rot_x
		 * @param rot_y the rot_y
		 * @param rot_z the rot_z
		 */
		public RotatePoint(float x, float y, float z, float rot_x,float rot_y,float rot_z)
		{
			super(x, y, z);
			rotate_x=rot_x;
			rotate_y=rot_y;
			rotate_z=rot_z;
		}

		/**
		 * Instantiates a new rotate point.
		 *
		 * @param newP the new p
		 * @param rot_x the rot_x
		 * @param rot_y the rot_y
		 * @param rot_z the rot_z
		 */
		public RotatePoint(Point newP, float rot_x,float rot_y,float rot_z)
		{
			super(newP);
			rotate_x=rot_x;
			rotate_y=rot_y;
			rotate_z=rot_z;
		}

		/**
		 * Instantiates a new rotate point.
		 *
		 * @param newP the new p
		 * @param oldP the old p
		 */
		public RotatePoint(Point newP, RotatePoint oldP)
		{
			super(newP);
			rotate_x=oldP.rotate_x;
			rotate_y=oldP.rotate_y;
			rotate_z=oldP.rotate_z;
		}

		/**
		 * Instantiates a new rotate point.
		 *
		 * @param x the x
		 * @param y the y
		 * @param z the z
		 * @param rot_x the rot_x
		 * @param rot_y the rot_y
		 * @param rot_z the rot_z
		 */
		public RotatePoint(double x, double y, double z, double rot_x,double rot_y,double rot_z)
		{
			super(x, y, z);
			rotate_x=(float) rot_x;
			rotate_y=(float) rot_y;
			rotate_z=(float) rot_z;
		}

		/* (non-Javadoc)
		 * @see no.ntnu.map.indoormaps.Point#toString()
		 */
		public String toString()
		{
			return super.toString()+" Rotate("+rotate_x+", "+rotate_y+", "+rotate_z+")";
		}
	}

	/**
	 * The z.
	 * @uml.property  name="x"
	 */
	public float x;

	/**
	 * The z.
	 * @uml.property  name="y"
	 */
	public float	y;

	/**
	 * The z.
	 * @uml.property  name="z"
	 */
	public float	z;

	/** The Constant Y. */
	public static final String TABLE_NAME="vertex";

	/** The Constant Y. */
	public static final String	PARENT="vertex_id";

	/** The Constant Y. */
	public static final String	_ID=TABLE_NAME+".id";

	/** The Constant Y. */
	public static final String	X="x";

	/** The Constant Y. */
	public static final String	Y="y";

	/**
	 * Instantiates a new point.
	 *
	 * @param p the p
	 */
	public Point(Point p)
	{
		this.x=p.x;
		this.y=p.y;
		this.z=p.z;
	}

	/**
	 * Instantiates a new point.
	 *
	 * @param x the x
	 * @param y the y
	 * @param z the z
	 */
	public Point(float x, float y, float z)
	{
		this.x=x;
		this.y=y;
		this.z=z;
	}

	/**
	 * Instantiates a new point.
	 *
	 * @param x the x
	 * @param y the y
	 * @param z the z
	 */
	public Point(double x, double y, double z)
	{
		this.x=(float) x;
		this.y=(float) y;
		this.z=(float) z;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString()
	{
		return "("+(int)x+", "+(int)y+", "+(int)z+")";
	}

	/**
	 * Calc angle.
	 *
	 * @param a_x the from_i
	 * @param a_y the from_j
	 * @param c_x the to_i
	 * @param c_y the to_j
	 * @return the float
	 */
	public static float calcAngle(float a_x,float a_y, float c_x, float c_y)
	{
		float b_x=a_x+10f, b_y=a_y;

		double abdi=b_x-a_x, abdj=b_y-a_y,
		acdi=c_x-a_x,acdj=c_y-a_y;

		double v= Math.acos((abdi*acdi+abdj*acdj)/(Math.sqrt(abdi*abdi+abdj*abdj)*Math.sqrt(acdi*acdi+acdj*acdj)));
		double sc=(acdi*(0-abdj)+acdj*abdi);

		if(sc>=0)return (float) Math.toDegrees(v);
		else return (float) -Math.toDegrees(v);
	}
}
