/*
 * 
 */
package no.ntnu.map.indoormaps;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.json.JSONArray;
import org.json.JSONObject;

// TODO: Auto-generated Javadoc
/**
 * The Class Storage.
 */
public class Storage
{

	/** The Constant D. */
	private static final boolean D=IndMap.D;

	/**
	 * The Interface InternalStorage.
	 */
	public static interface InternalStorage
	{

	}

	/**
	 * The Interface ExternalStorage.
	 */
	public static interface ExternalStorage
	{

		/**
		 * Next.
		 *
		 * @return true, if successful
		 */
		public boolean next();
	}

	/**
	 * The Class SQLStorage.
	 */
	public static abstract class SQLStorage implements ExternalStorage
	{

		/**
		 * The Class QueryBuilder.
		 */
		public static class QueryBuilder
		{

			/**
			 * The Class WrongTypeException.
			 */
			@SuppressWarnings("serial")
			public static class WrongTypeException extends Exception
			{

				/**
				 * Instantiates a new wrong type exception.
				 */
				public WrongTypeException()
				{
					super("Methood not allowed for this query type");
				}
			};

			/** The Constant CREATE. */
			public static final short SELECT=1;

			/** The Constant CREATE. */
			public static final short	INSERT=3;

			/** The Constant CREATE. */
			public static final short	UPDATE=2;

			/** The Constant CREATE. */
			public static final short	CREATE=4;

			/** The Constant DESC. */
			public static final boolean ASC=false;

			/** The Constant DESC. */
			public static final boolean	DESC=true;

			/** The Constant TAG. */
			public static final String EQUALS="=";

			/** The Constant TAG. */
			public static final String	LESS="<";

			/** The Constant TAG. */
			public static final String	MORE=">";

			/** The Constant TAG. */
			public static final String	EQLESS="<=";

			/** The Constant TAG. */
			public static final String	EQMORE="<=";

			/** The Constant TAG. */
			public static final String	NOT_EQUAL="!=";

			/** The Constant TAG. */
			public static final String	NULL="NULL";

			/** TAG used with {@link IndMap#log(short, String, String)}. */
			public static final String TAG="QueryBuilder";

			/** The type. */
			private short type;

			/** The ending. */
			private boolean newR;

			/** The ending. */
			private boolean	ending=true;

			/** The primary. */
			private String table;

			/** The primary. */
			private String	fields;

			/** The primary. */
			private String	where;

			/** The primary. */
			private String	group;

			/** The primary. */
			private String	have;

			/** The primary. */
			private String	order;

			/** The primary. */
			private String	limit;

			/** The primary. */
			private String	values;

			/** The primary. */
			private String	primary;

			/**
			 * Instantiates a new query builder.
			 *
			 * @param type the type
			 */
			public QueryBuilder(short type){this.type=type;}

			/**
			 * Instantiates a new query builder.
			 *
			 * @param type the type
			 * @param ending the ending
			 */
			public QueryBuilder(short type,boolean ending){this.type=type;this.ending=ending;}

			/**
			 * Gets the sql string.
			 *
			 * @return the sql string
			 */
			public String getSqlString()
			{
				String sql="";
				if(table==null)return null;
				switch(type)
				{
					case SELECT:
						if(fields==null)return null;
						sql= "SELECT "+fields+
						" FROM "+table+
						(where!=null?" WHERE "+where:"")+
						(group!=null?" GROUP BY "+group:"")+
						(have!=null?" HAVING "+have:"")+
						(order!=null?" ORDER BY "+order:"")+
						(limit!=null?" LIMIT "+limit:"")+(ending?";":"");
						break;
					case INSERT:
						if(values==null)return null;
						sql= "INSERT INTO "+table+(fields!=null?"("+fields+")":"")+" VALUES\n"+values+")"+(ending?";":"");
						break;
					case CREATE:
						sql= "CREATE TABLE "+table+"("+fields+(primary!=null?",PRIMARY KEY("+primary+")":"")+")"+(ending?";":"");
						break;

					default:
				}
				//IndMap.log(IndMap.DEBUG, TAG, sql);
				return sql;
			}

			/**
			 * Adds the field.
			 *
			 * @param column the column
			 * @throws WrongTypeException the wrong type exception
			 */
			public void addField(String column) throws WrongTypeException {addProjection(column);}

			/**
			 * Adds the fields.
			 *
			 * @param columns the columns
			 * @throws WrongTypeException the wrong type exception
			 */
			public void addFields(String[] columns) throws WrongTypeException {addProjection(columns);}

			/**
			 * Adds the field.
			 *
			 * @param column the column
			 * @param type the type
			 * @throws WrongTypeException the wrong type exception
			 */
			public void addField(String column, String type)throws WrongTypeException{addField(column,type,false);}

			/**
			 * Adds the field.
			 *
			 * @param column the column
			 * @param type the type
			 * @param primaryKey the primary key
			 * @throws WrongTypeException the wrong type exception
			 */
			public void addField(String column, String type,boolean primaryKey)throws WrongTypeException
			{
				if(this.type!=CREATE)throw new WrongTypeException();
				fields=(fields!=null?fields+",":"")+column+" "+type;
				if(primaryKey)primary=(primary!=null?primary+",":"")+column;
			}

			/**
			 * Adds the projection.
			 *
			 * @param column the column
			 * @throws WrongTypeException the wrong type exception
			 */
			public void addProjection(String column) throws WrongTypeException
			{
				if(type>INSERT)throw new WrongTypeException();
				fields=(fields!=null?fields+",":"")+column;
			}

			/**
			 * Adds the projection.
			 *
			 * @param columns the columns
			 * @throws WrongTypeException the wrong type exception
			 */
			public void addProjection(String[] columns) throws WrongTypeException
			{
				if(type>INSERT)throw new WrongTypeException();
				for(int i=0;i<columns.length;i++)addProjection(columns[i]);
			}

			/**
			 * Adds the table.
			 *
			 * @param table the table
			 * @throws WrongTypeException the wrong type exception
			 */
			public void addTable(String table) throws WrongTypeException
			{
				if(type>INSERT)throw new WrongTypeException();
				this.table=(this.table!=null?this.table+",":"")+table;
			}

			/**
			 * Sets the table.
			 * @param table  the new table
			 * @uml.property  name="table"
			 */
			public void setTable(String table){this.table=table;}

			/**
			 * Adds the where null.
			 *
			 * @param column the column
			 * @throws WrongTypeException the wrong type exception
			 */
			public void addWhereNull(String column) throws WrongTypeException
			{
				if(type>UPDATE)throw new WrongTypeException();
				where=(where!=null?where+" AND ":"")+column+" IS NULL";
			}

			/**
			 * Adds the where cond.
			 *
			 * @param column the column
			 * @param operator the operator
			 * @param value the value
			 * @throws WrongTypeException the wrong type exception
			 */
			public void addWhereCond(String column,String operator,String value) throws WrongTypeException
			{
				addJoinCond(column, operator, "'"+value.replace("'", "\'")+"'");
			}

			/**
			 * Adds the where cond.
			 *
			 * @param column the column
			 * @param operator the operator
			 * @param value the value
			 * @throws WrongTypeException the wrong type exception
			 */
			public void addWhereCond(String column,String operator,int value) throws WrongTypeException
			{
				if(type>UPDATE)throw new WrongTypeException();
				where=(where!=null?where+" AND ":"")+column+operator+Integer.toString(value);
			}

			/**
			 * Adds the join cond.
			 *
			 * @param column1 the column1
			 * @param operator the operator
			 * @param column2 the column2
			 * @throws WrongTypeException the wrong type exception
			 */
			public void addJoinCond(String column1,String operator,String column2) throws WrongTypeException
			{
				if(type>UPDATE)throw new WrongTypeException();
				where=(where!=null?where+" AND ":"")+column1+operator+column2;
			}

			/**
			 * Adds the group.
			 *
			 * @param group the group
			 * @param desc the desc
			 * @throws WrongTypeException the wrong type exception
			 */
			public void addGroup(String group,boolean desc) throws WrongTypeException
			{
				if(type>UPDATE)throw new WrongTypeException();
				group=(group!=null?group+",":"")+group+(desc?" desc":"");
			}

			/**
			 * Adds the group.
			 *
			 * @param group the group
			 * @throws WrongTypeException the wrong type exception
			 */
			public void addGroup(String group) throws WrongTypeException{addGroup(group, false);}

			/**
			 * Adds the having cond.
			 *
			 * @param column the column
			 * @param operator the operator
			 * @param value the value
			 * @throws WrongTypeException the wrong type exception
			 */
			public void addHavingCond(String column,String operator,String value) throws WrongTypeException
			{
				if(type>UPDATE)throw new WrongTypeException();
				have=(have!=null?have+",":"")+column+operator+value;
			}

			/**
			 * Adds the ordering.
			 *
			 * @param column the column
			 * @param desc the desc
			 * @throws WrongTypeException the wrong type exception
			 */
			public void addOrdering(String column,boolean desc) throws WrongTypeException
			{
				if(type>INSERT)throw new WrongTypeException();
				order=(order!=null?order+",":"")+column+(desc?" desc":"");
			}

			/**
			 * Adds the ordering.
			 *
			 * @param column the column
			 * @throws WrongTypeException the wrong type exception
			 */
			public void addOrdering(String column) throws WrongTypeException{addOrdering(column, false);}

			/**
			 * Adds the value.
			 *
			 * @param value the value
			 * @throws WrongTypeException the wrong type exception
			 */
			public void addValue(String value) throws WrongTypeException
			{
				if(type!=INSERT)throw new WrongTypeException();
				if(values==null)newRow();
				values=values+(newR?"":",")+"'"+value.replace("'", "\'")+"'";
				newR=false;
			}

			/**
			 * Adds the value.
			 *
			 * @param value the value
			 * @throws WrongTypeException the wrong type exception
			 */
			public void addValue(int value) throws WrongTypeException
			{
				if(type!=INSERT)throw new WrongTypeException();
				if(values==null)newRow();
				values=values+(newR?"":",")+Integer.toString(value);
				newR=false;
			}

			/**
			 * Adds the value.
			 *
			 * @param value the value
			 * @throws WrongTypeException the wrong type exception
			 */
			public void addValue(float value) throws WrongTypeException
			{
				if(type!=INSERT)throw new WrongTypeException();
				if(values==null)newRow();
				values=values+(newR?"":",")+value;
				newR=false;
			}

			/**
			 * New row.
			 *
			 * @throws WrongTypeException the wrong type exception
			 */
			public void newRow() throws WrongTypeException
			{
				if(type!=INSERT)throw new WrongTypeException();
				newR=true;
				values=(values==null?"(":values+"),\n(");
			}
		}

		/**
		 * Execute query.
		 *
		 * @param sql the sql
		 * @return the sQL storage
		 */
		public abstract SQLStorage executeQuery(String sql);
	}

	/*
	public class ResultSet extends JSONObject
	{
		private HTTPtoJSON parent;
		public ResultSet(HTTPtoJSON p){super();this.parent=p;}
		public void setParent(HTTPtoJSON p){this.parent=p;}
		public boolean next()
		{
			return parent.next();
		}
		public float getFloat(String name) throws JSONException
		{
			return (new Double(getDouble(name))).floatValue();
		}

	}
	 */
	/**
	 * The Class HTTPtoJSON.
	 */
	public static class HTTPtoJSON
	{

		/** TAG used with {@link IndMap#log(short, String, String)}. */
		private static final String TAG="HTTPtoJSON";

		/** The Constant D. */
		private static final boolean D=IndMap.D;

		/** The j array. */
		private JSONArray jArray=null;

		/** The index. */
		private int index=0;

		/**
		 * Instantiates a new hTT pto json.
		 *
		 * @param url the url
		 */
		public HTTPtoJSON(String url){this.url = url;}
		/*public HTTPtoJSON(String url,Listener listener)
		{
			addListener(listener);
			this.url=url;
		}
		 */
		/** The url. */
		private String url=null;

		/**
		 * Gets the uRL.
		 *
		 * @return the uRL
		 */
		public String getURL(){return url;}

		/**
		 * Sets the uRL.
		 *
		 * @param url the new uRL
		 */
		public void setURL(String url)
		{
			this.url=url;
			IndMap.log(IndMap.DEBUG, TAG, "Set URL to: "+(url!=null?url:"null"));
		}

		/** The is. */
		private InputStream	is=null;

		/** The sb. */
		private StringBuilder sb=null;

		/** The json. */
		private JSONObject json=new JSONObject();

		/**
		 * Gets the jSON object.
		 *
		 * @return the jSON object
		 */
		public JSONObject getJSONObject(){return json;}

		/**
		 * Gets the num json objects.
		 *
		 * @return the num json objects
		 */
		public int getNumJSONObjects()
		{
			return jArray.length();
		}

		/*
		public static interface Listener
		{
			void processResultFromHTTP();
		}
		private ArrayList<Listener> listeners=new ArrayList<Listener>();
		public void addListener(Listener l){listeners.add(l);};
		public void removeListener(Listener l){listeners.remove(l);}
		private void notifyListeners()
		{
			Iterator<Listener> i=listeners.iterator();
			while(i.hasNext())i.next().processResultFromHTTP();
		}
		 */

		/** The name value pairs. */
		private ArrayList<NameValuePair> nameValuePairs = new ArrayList<NameValuePair>();

		/**
		 * Adds the name value pair.
		 *
		 * @param nvp the nvp
		 */
		public void addNameValuePair(NameValuePair nvp){nameValuePairs.add(nvp);}

		/**
		 * Removes the name value pair.
		 *
		 * @param nvp the nvp
		 */
		public void removeNameValuePair(NameValuePair nvp){nameValuePairs.remove(nvp);}

		/**
		 * Clear name value pairs.
		 */
		public void clearNameValuePairs(){nameValuePairs.clear();}

		/**
		 * Execute.
		 */
		protected void execute()
		{
			if(url==null)return;
			try{
				HttpClient httpclient = new DefaultHttpClient();
				HttpPost httppost = new HttpPost(url);
				httppost.setEntity(new UrlEncodedFormEntity(nameValuePairs));
				HttpResponse response = httpclient.execute(httppost);
				HttpEntity entity = response.getEntity();
				is = entity.getContent();

				//if(D)IndMap.log(IndMap.DEBUG, TAG, "ask to "+url+" :"+nameValuePairs.toString());
			}catch(Exception e){
				IndMap.log(IndMap.ERROR, TAG, "Error in http connection"+e.toString());
				return;
			}
			//convert response to string
			try{
				BufferedReader reader = new BufferedReader(new InputStreamReader(is,"iso-8859-1"),8);
				sb = new StringBuilder();
				sb.append(reader.readLine() + "\n");
				String line="0";
				while ((line = reader.readLine()) != null) {
					sb.append(line + "\n");
				}
				is.close();
				//if(D)IndMap.log(IndMap.DEBUG, TAG, "got :"+result.substring(0,(150>result.length()?result.length():150)));
			}catch(Exception e){
				IndMap.log(IndMap.ERROR, TAG, "Error converting result "+e.toString());
				return;
			}
			//paring data
			try{
				jArray = new JSONArray(sb.toString());
				if(D)IndMap.log(IndMap.DEBUG, TAG, "got :"+jArray.length()+" elements");
			}
			catch(Exception e){
				IndMap.log(IndMap.ERROR, TAG, "Error JSON parsing "+e.toString());
				return;
			}
			index=-1;
			//notifyListeners();
		}

		/**
		 * Next.
		 *
		 * @return true, if successful
		 */
		public boolean next()
		{
			boolean ok=(index+1<jArray.length()&&jArray.length()>0);

			if(ok)
			{
				index++;
				try
				{
					json=jArray.getJSONObject(index);
				} catch (Exception e)
				{
					IndMap.log(IndMap.ERROR, TAG, "Feilet nytt element: "+e.toString());
					return false;
				}
			}
			return ok; 
		}
	}

	/**
	 * The Class MysqlViaPHP.
	 */
	public static class MysqlViaPHP extends HTTPtoJSON
	{

		/** TAG used with {@link IndMap#log(short, String, String)}. */
		private static final String TAG="MysqlViaPHP";

		/**
		 * Instantiates a new mysql via php.
		 *
		 * @param url the url
		 */
		MysqlViaPHP(String url)
		{
			super(url);
		}

		/*public MysqlViaPHP(String string, Listener listener)
		{
			super(string,listener);
		}*/

		/**
		 * Execute query.
		 *
		 * @param sql the sql
		 */
		public void executeQuery(String sql)
		{
			addNameValuePair(new BasicNameValuePair("query",sql));
			if(D)IndMap.log(IndMap.DEBUG, TAG, "Binded key 'query' and value '"+sql+"'");
			execute();
			clearNameValuePairs();
		}

		/**
		 * To float.
		 *
		 * @param d the d
		 * @return the float
		 */
		public static float toFloat(Double d)
		{
			Double e=new Double(d);
			return e.floatValue();
		}
	}
}